openerp.purchase_print_report = function (instance, local) {
    local.widgetInstance = null;
    local.parentInstance = null;

    local.PrintPurchaseWidget = instance.Widget.extend({
        template : "purchase_print_report.PrintPurchase",
        resInvoice:[],
        resPartner:[],
        partner:[],
        resInvoiceLine:[],
        jsonDoc:[],
        // Init
        fields: ['number', 'date_order', 'partner_id', 'amount_untaxed', 'amount_tax', 'amount_total'],

        init:function(parent, modelo, ids_seleccionados){
            this._super(parent);

            this.modelo = modelo;
            this.ids_seleccionados = ids_seleccionados;
        },

        // Verificar si los Valores no son nulos
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },

        start: function () {
            var self = this;
            var doc=[];
            var amount=0;
            var amount_tx=0;
            var amount_untax=0;

            this.obtener_facturas().then(function (facturas) {
                // cuerpo del pdf
                for (var i = 0; i < facturas.length; i++) {
                    doc.push({
                        number : self.valorNull(facturas[i].number),
                        date_invoice : moment(facturas[i].date_order).format("DD/MM/YYYY"),
                        partner_id : facturas[i].partner_id[1],
                        amount_untaxed : accounting.formatNumber(facturas[i].amount_untaxed,2,".",","),
                        amount_tax : accounting.formatNumber(facturas[i].amount_tax,2,".",","),
                        amount_total : accounting.formatNumber(facturas[i].amount_total,2,".",",")
                    })

                amount_untax+=facturas[i].amount_untaxed;
                amount_tx+=facturas[i].amount_tax;
                amount+=facturas[i].amount_total;
            }
                doc.push({
                        number: "",
                        date_invoice: "",
                        partner_id : "Totales",
                        amount_untaxed: accounting.formatNumber((amount_untax),2,".",","),
                        amount_tax: accounting.formatNumber((amount_tx),2,".",","),
                        amount_total: accounting.formatNumber((amount),2,".",",")
                    });

                self.drawPDF_pdf(doc);
            });
        },

        obtener_facturas: function () {
            var Factura = new instance.web.Model('purchase.order');
            return Factura.query(this.fields).filter([['id', 'in', this.ids_seleccionados]]).order_by('id').all();
        },

        drawPDF_pdf: function (facturas) {
            var documento = new jsPDF();

            // cabecera del pdf
            var columns = [
                     {title: "Numero"},
                     {title: "Fecha"},
                     {title: "Proveedor"},
                     {title: "Subtotal"},
                     {title: "IVA"},
                     {title: "Total"}
            ];

            documento.autoTable(columns, _.map(facturas, function (factura) {
                return _.values(factura);
                }), {
                    styles: {overflow: 'linebreak', fontSize:8 },
                    columnStyles:{
                            number : {columnWidth: '8px'},
                            date_invoice : {columnWidth: '8px'},
                            partner_id : {columnWidth: '8px'},
                            amount_untaxed : {halign:'right',columnWidth: '8px'},
                            amount_tax :{halign:'right',columnWidth: '6px'},
                            amount_total : {halign:'right',columnWidth: '8px'},
                        },
                    margin: {top: 40},
                    addPageContent: function(data) {
        	        documento.text("Listado de Facturas de Compras", 45, 30,'center');
                    }

                });


            documento.save('listado_compra_' + Date.now() + '.pdf');
        }

    })

    if(instance.web && instance.web.ListView){
        instance.web.ListView.include({
            do_show: function() {
                this._super.apply(this, arguments);
                if (this.model != 'purchase.order') return

                var self = this;
                this.sidebar.add_items('print', [
                    {
                        label: 'Listado de Compras Generales',
                        classname: 'oe_sidebar_print',
                        callback: function () {
                            var widget = new local.PrintPurchaseWidget(self, self.model, self.get_selected_ids());
                            widget.start()
                        }
                    }
                ])
            }
        })

    }
}
